var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Base Manipulators</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Base Manipulators</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"base-manipulators\"></a></div>\n\
<p>Base manipulators are a set of simple manipulators. They operate on data types that range from a single boolean, integer, or floating point value to vectors with floating point values of different lengths.</p>\n\
<p>The OpenMaya API supports the following base manipulator classes that can be combined to form a composite manipulator. All the function sets for the base manipulators are derived from the <span class=\'code\'>MFnManip3D</span> class.</p>\n\
<ul>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#freepointtriadmanip\' title=\'\'>FreePointTriadManip</a>: <span class=\'code\'>MFnFreePointTriadManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#directionmanip\' title=\'\'>DirectionManip</a>: <span class=\'code\'>MFnDirectionManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#distancemanip\' title=\'\'>DistanceManip</a>: <span class=\'code\'>MFnDistanceManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#pointoncurvemanip\' title=\'\'>PointOnCurveManip</a>: <span class=\'code\'>MFnPointOnCurveManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#pointonsurfacemanip\' title=\'\'>PointOnSurfaceManip</a>: <span class=\'code\'>MFnPointOnSurfaceManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#discmanip\' title=\'\'>DiscManip</a>: <span class=\'code\'>MFnDiscManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#circlesweepmanip\' title=\'\'>CircleSweepManip</a>: <span class=\'code\'>MFnCircleSweepManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#togglemanip\' title=\'\'>ToggleManip</a>: <span class=\'code\'>MFnToggleManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#statemanip\' title=\'\'>StateManip</a>: <span class=\'code\'>MFnStateManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#curvesegmentmanip\' title=\'\'>CurveSegmentManip</a>: <span class=\'code\'>MFnCurveSegmentManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#rotatemanip\' title=\'\'>RotateManip</a>: <span class=\'code\'>MFnRotateManip</span></li>\n\
<li><a href=\'#!/url=./dev_help/Manipulators/Base-Manipulators.html#scalemanip\' title=\'\'>ScaleManip</a>: <span class=\'code\'>MFnScaleManip</span></li>\n\
</ul>\n\
<p>The function set classes are used for creating the base manipulators with corresponding <span class=\'code\'>create()</span> functions, and to set some properties of the base manipulators. The function set classes are also used to set relationships between values of the manipulator visual controls and values of the attributes (plugs) on nodes. The function set classes communicate with the attributes (plugs) to set their values based on the visual control values.</p>\n\
<div class=\'section\'><a id=\"freepointtriadmanip\"></a><h2 id=\"freepointtriadmanip\">FreePointTriadManip</h2></div>\n\
<p>The FreePointTriadManip provides a point that can be moved anywhere. It has axes for constrained x, y, and z movement and obeys grid snapping, point snapping, and curve snapping.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/FreePointTriadManip.png\' title=\'\'></div>\n\
<p>The FreePointTriadManip generates the 3D position of a point, which is useful for specifying the position of an object in space.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> The FreePointTriadManip is a subset of moveManip in Maya.</p>\n\
</blockquote>\n\
<p>The <span class=\'code\'>MFnFreePointTriadManip</span> class can be used to create the manipulator and set the manipulator properties. For example, <span class=\'code\'>MFnFreePointTriadManip::setDrawAxes()</span> can be used to set whether or not to draw the axes, and <span class=\'code\'>MFnFreePointTriadManip::setSnapMode()</span> can be used to set whether or not to use the snap mode.</p>\n\
<div class=\'section\'><a id=\"directionmanip\"></a><h2 id=\"directionmanip\">DirectionManip</h2></div>\n\
<p>The DirectionManip allows you to specify a direction as defined by a vector from the start point to the manipulator position. It uses a FreePointTriadManip to specify an end point of the vector relative to a given start point. This manipulator generates a vector from the start point to the end point.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/DirectionManip.png\' title=\'\'></div>\n\
<p>The <span class=\'code\'>MFnDirectionManip</span> class can be used to create the manipulator and set the manipulator properties.</p>\n\
<div class=\'section\'><a id=\"distancemanip\"></a><h2 id=\"distancemanip\">DistanceManip</h2></div>\n\
<p>The DistanceManip allows you to manipulate a point that is constrained to move along a line. The distance value is calculated from the start point of the line to the manipulated point. This manipulator generates a single floating point value. Scaling factors can be used to determine how long the manipulator appears when it is drawn.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/DistanceManip.png\' title=\'\'></div>\n\
<p>The API class for DistanceManip is <span class=\'code\'>MFnDistanceManip</span>.</p>\n\
<div class=\'section\'><a id=\"pointoncurvemanip\"></a><h2 id=\"pointoncurvemanip\">PointOnCurveManip</h2></div>\n\
<p>The PointOnCurveManip allows you to manipulate a point that is constrained to move along a curve and specify the <em>u</em> curve parameter value. This manipulator generates a single floating point value corresponding to the curve parameter.</p>\n\
<p>The API class for PointOnCurveManip is <span class=\'code\'>MFnPointOnCurveManip</span>.</p>\n\
<div class=\'section\'><a id=\"pointonsurfacemanip\"></a><h2 id=\"pointonsurfacemanip\">PointOnSurfaceManip</h2></div>\n\
<p>The PointOnSurfaceManip allows you to manipulate a point that is constrained to move along a surface and specify the <em>(u, v)</em> surface parameter values. This manipulator generates two floating point values corresponding to the surface (u, v) parameters.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/PointOnSurfaceManip.png\' title=\'\'></div>\n\
<p>The API class for PointOnSurfaceManip is <span class=\'code\'>MFnPointOnSurfaceManip</span>.</p>\n\
<div class=\'section\'><a id=\"discmanip\"></a><h2 id=\"discmanip\">DiscManip</h2></div>\n\
<p>The DiscManip allows you to rotate a disc to specify a rotation about an axis. This manipulator generates a single floating point value corresponding to the rotation.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/DiscManip.png\' title=\'\'></div>\n\
<p>The API class for DiscManip is <span class=\'code\'>MFnDiscManip</span>.</p>\n\
<div class=\'section\'><a id=\"circlesweepmanip\"></a><h2 id=\"circlesweepmanip\">CircleSweepManip</h2></div>\n\
<p>The CircleSweepManip allows you to manipulate a point constrained to move around a circle and specify a sweep angle. This manipulator generates a single floating point value corresponding to the sweep angle. The CircleSweepManip is similar to the DiscManip, but it provides more options for specifying the rotating angles.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/CircleSweepManip.png\' title=\'\'></div>\n\
<p>The API class for CircleSweepManip is <span class=\'code\'>MFnCircleSweepManip</span>.</p>\n\
<div class=\'section\'><a id=\"togglemanip\"></a><h2 id=\"togglemanip\">ToggleManip</h2></div>\n\
<p>The ToggleManip allows you to switch between two modes or on/off states. It is drawn as a circle with or without a dot. When the mode is on, the dot is drawn in the circle and when the mode is off, the circle is drawn without the dot. This manipulator generates a boolean value corresponding to whether or not the mode is on or off.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/ToggleManip.png\' title=\'\'></div>\n\
<p>The API class for ToggleManip is <span class=\'code\'>MFnToggleManip</span>.</p>\n\
<div class=\'section\'><a id=\"statemanip\"></a><h2 id=\"statemanip\">StateManip</h2></div>\n\
<p>The StateManip allows you to switch between multiple states. It is drawn as a circle with a notch. Each click on the circle increments the value of the state. This manipulator generates an integer value corresponding to the state of the manipulator.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/StateManip.png\' title=\'\'></div>\n\
<p>The API class for StateManip is <span class=\'code\'>MFnStateManip</span>.</p>\n\
<div class=\'section\'><a id=\"curvesegmentmanip\"></a><h2 id=\"curvesegmentmanip\">CurveSegmentManip</h2></div>\n\
<p>The CurveSegmentManip allows you to manipulate two points on a curve to specify a curve segment. This manipulator generates two floating point values, which correspond to the parameters of the start and end of the curve segment.</p>\n\
<p>The API class for CurveSegmentManip is <span class=\'code\'>MFnCurveSegmentManip</span>.</p>\n\
<div class=\'section\'><a id=\"rotatemanip\"></a><h2 id=\"rotatemanip\">RotateManip</h2></div>\n\
<p>The RotateManip corresponds to the built-in rotate manipulator in Maya, and it allows you to manipulate a 3d rotation vector. The manipulator consists of three constrained-axis rotation rings, a view rotation ring, and an invisible trackball that allows you to rotate in arbitrary directions in a sphere. It supports the three rotation modes of the built-in rotate manipulator: object space, global, and gimbal. It allows constrained rotation on the x, y, z, and viewing axes. The vector generated by the manipulator is an Euler rotation that is suitable for input to a rotation plug.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/RotateManip.png\' title=\'\'></div>\n\
<p>The API class for RotateManip is <span class=\'code\'>MFnRotateManip</span>.</p>\n\
<div class=\'section\'><a id=\"scalemanip\"></a><h2 id=\"scalemanip\">ScaleManip</h2></div>\n\
<p>The ScaleManip corresponds to the built-in scale manipulator in Maya, and it allows you to manipulate the relative x, y, and z scaling values. The scale manipulator provides a central handle for proportional scaling, as well as x, y, and z axis handles for non-proportional scaling on each axis. The manipulator generates a relative scaling vector that is suitable for input to a scale plug.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/ScaleManip.png\' title=\'\'></div>\n\
<p>The API class for scaleManip is <span class=\'code\'>MFnScaleManip</span>.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";