var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>MArgList</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>MArgList</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"marglist\"></a></div>\n\
<p>The <span class=\'code\'>MArgList</span> class provides an entry point for a list of arguments that are passed to your command plug-in.</p>\n\
<p><span class=\'code\'>MArgList</span> is similar to the <span class=\'code\'>argc</span> and <span class=\'code\'>argv</span> parameters in C and C++. However, an important difference between <span class=\'code\'>MArgList</span> and <span class=\'code\'>argv</span>/<span class=\'code\'>argc</span> parameters is that the zeroth element of an <span class=\'code\'>MArgList</span> is the first argument to the command and not the command name itself.</p>\n\
<p>The list of arguments is passed to <span class=\'code\'>MPxCommand::doIt()</span>. For example,</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">MStatus doHelix::doIt( const MArgList&amp; args )\n\
</pre></div><p>Use a loop to parse the individual arguments from the list. For example,</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">// Parse the arguments.\n\
for ( i = 0; i &lt; args.length(); i++ )\n\
    if ( MString( &quot;-p&quot; ) == args.asString( i ) )\n\
        pitch = args.asDouble( ++i );\n\
    else if ( MString( &quot;-r&quot; ) == args.asString( i ) )\n\
        radius = args.asDouble( ++i );\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";