var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>MObject and function sets</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>MObject and function sets</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"mobject-and-function-sets\"></a></div>\n\
<p>Maya&#39;s internal modelling, animation and rendering objects, as well as all the directed graph nodes and their attributes, are referred to as model objects.</p>\n\
<p>Function set classes, which have the <span class=\'code\'>MFn</span> prefix, provide functions for manipulating specific model objects. For example, MFnNurbsSurface provides functions for manipulating NURBS surfaces.</p>\n\
<p>The MObject class provides a generic interface to access model objects. Each MObject is a handle to the underlying model object that is being manipulated by the function set. As such, calling the destructor on the MObject will only destroy the MObject and not the underlying model object it represents.</p>\n\
<p>An MObject is created with a function set&#39;s <span class=\'code\'>create()</span> method. Each function set implements its own <span class=\'code\'>create()</span> method and the MObject it creates acquires that function set&#39;s type. Because of inheritance, the MObject will be compatible with all the function sets from which its function set type was derived.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> An MObject will not be compatible with function sets that are derived from its function set type.</p>\n\
</blockquote>\n\
<p>Various methods are available to query an MObject&#39;s type. If you are unsure of the type of an MObject, use the <span class=\'code\'>apiType()</span> method to get the MObject&#39;s type. The return value will be a type in <span class=\'code\'>MFn::Type</span>. If you want to know if an MObject is compatible with a specific function set, pass the function set type to the <span class=\'code\'>hasFn()</span> method.</p>\n\
<p>Because MObject is a generic type, passing an MObject to an incompatible function set will not generate a compiler error. An error will only be generated at runtime.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";