var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Naming Conventions</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Naming Conventions</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"naming-conventions\"></a></div>\n\
<p>The Maya API uses a convention of prefixes on its classes to distinguish the various types of C++ objects that it uses.</p>\n\
<ul>\n\
<li><strong>MFn</strong> - Any class with this prefix is a function set used to operate on MObjects of a particular type.</li>\n\
<li><strong>MIt</strong> - These classes are iterators and work on <span class=\'code\'>MObject</span>s much the way a function set does. For example, <span class=\'code\'>MItCurveCV</span> is used to operate on an individual NURBS curve CV (there is no <span class=\'code\'>MFnNurbsCurveCV</span>), or iteratively, on all the CVs of a curve.</li>\n\
<li><strong>MPx</strong> - Classes with this prefix are all <a href=\'#!/url=./dev_help/Maya-API-introduction/Objects-and-Function-Sets.html#proxies\' title=\'\'>Proxies</a>, API classes designed for you to derive from and create your own object types.</li>\n\
<li><strong>M classes</strong> - Most of these classes are <a href=\'#!/url=./dev_help/Maya-API-introduction/Wrappers.html\' title=\'\'>Wrappers</a>, though there are others. For example, an instance of <span class=\'code\'>MObject</span> is a handle on Maya’s internal objects, and <span class=\'code\'>MGlobal</span> is a class of static methods that operate globally and do not require an <span class=\'code\'>MObject</span> on which to operate. (See <a href=\'#!/url=./dev_help/Selecting-with-the-API.html\' title=\'\'>Selecting with the API</a> for information on <span class=\'code\'>MGlobal</span>.)</li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";