var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>MItSelectionList</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>MItSelectionList</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"mitselectionlist\"></a></div>\n\
<p><span class=\'code\'>MItSelectionList</span> is a wrapper class containing selected objects. This can either be a copy of the global active selection list, or a list you build yourself.</p>\n\
<p><span class=\'code\'>MItSelectionList</span> lets you filter the objects on the selection list to only see objects of a particular type (<span class=\'code\'>MSelectionList</span> does not let you filter selected objects).</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">MGlobal::getActiveSelectionList( list );\n\
for ( MItSelectionList listIter( list ); !listIter.isDone(); listIter.next() )\n\
{\n\
    listIter.getDagPath( node, component );\n\
    nodeFn.setObject( node );\n\
    cout &lt;&lt; nodeFn.name().asChar() &lt;&lt; &quot;%s is selected” &lt;&lt; endl;\n\
}\n\
\n\
</pre></div><p>The <a href=\'#!/url=./dev_help/Selecting-with-the-API/MSelectionList.html\' title=\'\'>MSelectionList</a> example can be changed with this code fragment to use <span class=\'code\'>MItSelectionList</span> instead to iterate through the selection list. This produces exactly the same results as before when selecting objects.</p>\n\
<p>You can easily change the code to only look for objects of a particular type. For example, changing the constructor of the selection list iterator to:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">MItSelectionList listIter( list, MFn::kNurbsSurface )\n\
\n\
</pre></div><p>causes the loop to only iterate across selected NURB surfaces—it also ignores surface CVs. If, however, you wanted to just iterate across selected surface CVs, you would change the iterator to:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">MItSelectionList listIter( list, MFn::kSurfaceCVComponent )\n\
\n\
</pre></div><p>which would only iterate across surfaces with selected CVs.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";