var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Draw Overrides</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Draw Overrides</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"draw-overrides\"></a></div>\n\
<p><span class=\'code\'>MPxDrawOverride</span> is the API entry point for defining low-level drawing of plug-in DAG objects in Viewport 2.0. It is designed as a back door for legacy (for example, fixed function) draw code which gives complete and total control (and responsibility) for drawing the associated DAG object regardless of shader assignment. Due to the wide-open nature of the interface, Maya cannot attempt to optimize the rendering of objects which draw using this interface (for example, no consolidation, no vertex data sharing, and so forth). This interface is not draw API agnostic; multiple code paths need to be written and maintained if the plug-in needs to support both OpenGL and DirectX. There is no integration with lighting. Transparency is supported; however <span class=\'code\'>MPxDrawOverride</span> does not support advanced transparency algorithms such as weighted average or depth peeling, even if <span class=\'code\'>MPxDrawOverride::isTransparent()</span> is set to true. When either the Weighted Average or Depth Peeling transparency algorithm is selected, the default Object Sorting algorithm is used instead. Effects can be supported via <span class=\'code\'>MPxDrawOverride::excludedFromPostEffects()</span>. Unlike <span class=\'code\'>MPxGeometryOverride</span> or <span class=\'code\'>MPxShaderOverride</span>, where part of the setup is done by Maya, <span class=\'code\'>MPxDrawOverride</span> requires the plug-in author to perform all shader setup, geometry binding, and draw calls manually. The interface gives the highest level of power for managing the draw of plug-in DAG objects, but also comes with a matching level of responsibility.</p>\n\
<p>Implementations of <span class=\'code\'>MPxDrawOverride</span> must be registered with <span class=\'code\'>MDrawRegistry</span> using classification strings. The classification string must begin with &quot;drawdb/geometry&quot; in order to be properly recognized by the system. DAG objects with classification strings that satisfy the override classification string are evaluated using the override. Maya creates one instance of the registered <span class=\'code\'>MPxDrawOverride</span> for each associated DAG object.</p>\n\
<p>The override has several helper methods: <span class=\'code\'>transform()</span>, <span class=\'code\'>boundingBox()</span> and <span class=\'code\'>isBounded()</span> which may be called by Maya before drawing to obtain information about the drawable scene management purposes. Maya will draw the bounding box for an <span class=\'code\'>MPxDrawOverride</span> when in “bounding box” display mode. If <span class=\'code\'>isBounded()</span> returns a false value then there is no way for Maya to determine what to draw. The <span class=\'code\'>MPxDrawOverride</span> is responsible for drawing its own bounding box in this case.</p>\n\
<p>The actual draw occurs on every refresh, and consists of two stages: <strong>preparation</strong> and <strong>execution</strong>.</p>\n\
<p>Any required data from the Maya dependency graph must be retrieved and cached in the <span class=\'code\'>prepareForDraw()</span> stage. It is invalid to pull data from the Maya dependency graph in the draw method and Maya may become unstable as a result. Implementations may allow Maya to handle the data caching by returning a pointer to the data from this method. This same pointer is passed to the draw callback. On subsequent draws, the pointer is also be passed back into the <span class=\'code\'>prepareForDraw()</span> method so that the data may be modified and reused instead of reallocated.</p>\n\
<p>In the draw method, the override is free to act as necessary to draw the object (apart from triggering evaluation of the Maya dependency graph). Access to device information can be obtained through <span class=\'code\'>MDrawContext</span>, and the override can make use of <span class=\'code\'>MStateManager</span> and <span class=\'code\'>MTextureManager</span> to handle device state and resources. If the override needs to modify the state (in any manner), to avoid draw corruption, it must be sure to restore that state before completing execution.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8cf5.jpg\' title=\'\'></div>\n\
<p>Figure 44: The draw override supplies transform and bounds information for any culling, will be called to perform draw preparation during the “Update Phase” and then called to perform drawing during the “Draw Phase.” Intermediate phases between updating and drawing are skipped over.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";