var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Developer Kit Samples</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Developer Kit Samples</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"developer-kit-samples\"></a></div>\n\
<div class=\'section\'><a id=\"footprintnode\"></a><h2 id=\"footprintnode\">footPrintNode</h2></div>\n\
<p>The <em>footPrintNode</em> plug-in is an example of using <span class=\'code\'>MPxLocatorNode</span>. It has been updated to provide a simple Viewport 2.0 implementation as well as an example of using <span class=\'code\'>MPxDrawOverride</span>. Not all draw modes are supported, but it shows how <span class=\'code\'>MPxDrawOverride</span> is meant to be used.</p>\n\
<div class=\'section\'><a id=\"apimeshshape\"></a><h2 id=\"apimeshshape\">apiMeshShape</h2></div>\n\
<p>The <em>apiMeshShape</em> plug-in is an example of how to implement a custom Maya shape using <span class=\'code\'>MPxSurfaceShape</span>. It has been updated to include how to use <span class=\'code\'>MPxGeometryOverride</span> in order to provide vertex data, index data, and custom render items to Viewport 2.0 for drawing a custom Maya shape with arbitrary shader assignments.</p>\n\
<p>The <em>apiMeshShape</em> plug-in also has an example implementation of the <span class=\'code\'>MPxSubSceneOverride</span> interface. This implementation is disabled by default but can be activated by modifying and rebuilding the plug-in.</p>\n\
<div class=\'section\'><a id=\"gpucache\"></a><h2 id=\"gpucache\">gpuCache</h2></div>\n\
<p>The <em>gpuCache</em> plug-in uses the <span class=\'code\'>MPxSurfaceShape</span> interface to implement an opaque scene caching node. The node can efficiently store and display a complex sub-scene rooted at the node which is unknown to the rest of Maya. The plug-in defines two different Viewport 2.0 implementations that are selectable by the environment variable MAYA_GPUCACHE_VP2_OVERRIDE_API. There is one implementation for each interface, <span class=\'code\'>MPxDrawOverride</span>, and <span class=\'code\'>MPxSubSceneOverride</span>. See Rendering variables in the Maya User&#39;s Guide for more information about this environment variable.</p>\n\
<div class=\'section\'><a id=\"hwphongshader\"></a><h2 id=\"hwphongshader\">hwPhongShader</h2></div>\n\
<p><em>hwPhongShader</em> is an example of how to implement a custom hardware shader using <span class=\'code\'>MPxHwShaderNode</span>. It has been updated to include how to use <span class=\'code\'>MPxShaderOverride</span> to implement a complete custom shading effect for Viewport 2.0. In its primary mode, it uses the simple drawGeometry interface to allow Viewport 2.0 to handle geometry drawing after it sets up the shader. However, it also has an alternate implementation that shows how to query the actual geometry resource handles through the <span class=\'code\'>MGeometry</span> interface in order to do custom binding and drawing.</p>\n\
<div class=\'section\'><a id=\"cgfx\"></a><h2 id=\"cgfx\">cgFx</h2></div>\n\
<p>Maya’s CgFX plug-in has been updated to support Viewport 2.0 through the <span class=\'code\'>MPxShaderOverride</span> interface. Unlike <em>hwPhongShader</em> above, this is a non-trivial example of using the new API to produce fast and interesting custom shading. The plug-in makes extensive use of <span class=\'code\'>MDrawContext</span> in order to set and maintain state as the plug-in renders the custom CgFX file shaders.</p>\n\
<div class=\'section\'><a id=\"dx11shader\"></a><h2 id=\"dx11shader\">dx11Shader</h2></div>\n\
<p>This plug-in defines a Maya shading node using the <span class=\'code\'>MPxHardwareShader</span> interface to support DirectX 11 in Viewport 2.0. Like the CgFX plug-in, the attributes of the node are dynamically created based on a shader effect file (except in this case, it is an HLSL effect instead of a Cg effect). Also, like the CgFX plug-in, this node is supported in Viewport 2.0 using the <span class=\'code\'>MPxShaderOverride</span> interface and is another very good, non-trivial example of the full capabilities of this interface. This plug-in also shows examples of advanced shading and geometry manipulation to achieve effects like hardware displacement and tessellation.</p>\n\
<div class=\'section\'><a id=\"example-uses-of-mpxshadingnodeoverride\"></a><h2 id=\"example-uses-of-mpxshadingnodeoverride\">Example Uses of MPxShadingNodeOverride</h2></div>\n\
<p>The following plug-ins all implement <span class=\'code\'>MPxShadingNodeOverride</span> to provide Viewport 2.0 support for the software shading nodes defined by the plug-ins: <em>brickShader</em>, <em>checkerShader</em>, <em>fileTexture</em>, <em>contrastShader</em>, <em>gammaShader</em> and <em>mixtureShader</em>. These six plug-ins together provide a good overview of the functionality of this interface.</p>\n\
<div class=\'section\'><a id=\"example-uses-of-mpxsurfaceshadingnodeoverride\"></a><h2 id=\"example-uses-of-mpxsurfaceshadingnodeoverride\">Example Uses of MPxSurfaceShadingNodeOverride</h2></div>\n\
<p>The following plug-ins all implement <span class=\'code\'>MPxSurfaceShadingNodeOverride</span> in order to provide Viewport 2.0 support for the software surface shading nodes defined by the plug-ins: <em>lambertShader</em>, <em>phongShader</em> and <em>depthShader</em>. These three plug-ins together provide a good overview of all the functionality of this interface and also provide good examples of some of the features of the base class, <span class=\'code\'>MPxShadingNodeOverride.</span></p>\n\
<div class=\'section\'><a id=\"viewrenderoverride\"></a><h2 id=\"viewrenderoverride\">viewRenderOverride</h2></div>\n\
<p>The <em>viewRenderOverride</em> plug-in is an example of how to override the viewport drawing to produce various effects on top of the standard draw. This makes use of many new API classes including: <span class=\'code\'>MRenderer</span>, <span class=\'code\'>MRenderOverride</span>, <span class=\'code\'>MRenderOperation</span> (and several of its derived classes), <span class=\'code\'>MCameraOverride</span> and <span class=\'code\'>MRenderTarget</span>.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";