var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Transition Guide</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Transition Guide</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"transition-guide\"></a></div>\n\
<div class=\'section\'><a id=\"mpxlocatornode\"></a><h2 id=\"mpxlocatornode\"><span class=\'code\'>MPxLocatorNode</span></h2></div>\n\
<p>Support for Maya nodes implementing the <span class=\'code\'>MPxLocatorNode</span> interface can be added by providing an implementation of <span class=\'code\'>MPxDrawOverride</span> and registering it with <span class=\'code\'>MDrawRegistry</span> against a classification string for the Maya plugin node type. See the Developer Kit example <em>footPrintNode</em> for more details.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> The <span class=\'code\'>MPxLocatorNode::isTransparent()</span> and <span class=\'code\'>MPxLocatorNode::drawLast()</span> interfaces are not supported in Viewport 2.0. See the <em>uiDrawManager</em> plug-in example in the Developer Kit for an example of how to draw semi-transparent objects for locators in Viewport 2.0.</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"mpxsurfaceshapempxcomponentshape\"></a><h2 id=\"mpxsurfaceshapempxcomponentshape\"><span class=\'code\'>MPxSurfaceShape/MPxComponentShape</span></h2></div>\n\
<p>Support for Maya nodes implementing these interfaces can be added by providing an implementation of <span class=\'code\'>MPxGeometryOverride</span> and registering it with <span class=\'code\'>MDrawRegistry</span> against a classification string for the Maya plugin node type. See the Developer Kit example <em>apiMeshShape</em> for more details.</p>\n\
<div class=\'section\'><a id=\"mpxhwshadernodempxhardwareshader\"></a><h2 id=\"mpxhwshadernodempxhardwareshader\"><span class=\'code\'>MPxHwShaderNode/MPxHardwareShader</span></h2></div>\n\
<p>Support for Maya nodes implementing these interfaces can be added by providing an implementation of <span class=\'code\'>MPxShaderOverride</span> and registering it with <span class=\'code\'>MDrawRegistry</span> against a classification string for the Maya plugin node type. See the Developer Kit example <em>hwPhongShader</em> for more details.</p>\n\
<div class=\'section\'><a id=\"software-shading-nodes-derived-from-mpxnode\"></a><h2 id=\"software-shading-nodes-derived-from-mpxnode\">Software Shading Nodes derived from <span class=\'code\'>MPxNode</span></h2></div>\n\
<p>Support for software shading nodes implementing the <span class=\'code\'>MPxNode</span> interface can be added by providing an implementation of <span class=\'code\'>MPxShadingNodeOverride</span> and registering it with <span class=\'code\'>MDrawRegistry</span> against a classification string for the Maya plug-in node type. See the Developer Kit example <em>brickShader</em> for more details.</p>\n\
<p>Support for software surface shading nodes (those which may be connected directly to the Maya shading engine) implementing the <span class=\'code\'>MPxNode</span> interface can be added by providing an implementation of <span class=\'code\'>MPxSurfaceShadingNodeOverride</span> and registering it with <span class=\'code\'>MDrawRegistry</span> against a classification string for the Maya plug-in node type. See the Developer Kit example <em>phongShader</em> for more details.</p>\n\
<div class=\'section\'><a id=\"m3dviewmpx3dmodelview\"></a><h2 id=\"m3dviewmpx3dmodelview\"><span class=\'code\'>M3dView/MPx3dModelView</span></h2></div>\n\
<p>Custom renderer definitions for Viewport 2.0 can be provided using the new rendering override interfaces <span class=\'code\'>MRenderOverride</span> and <span class=\'code\'>MRenderOperation</span>. See the Developer Kit example <em>viewRenderOverride</em> for more details</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";