var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>What&#39;s New in the Maya 2019 devkit</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>What&#39;s New in the Maya 2019 devkit</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"whats-new-in-the-maya-2019-devkit\"></a></div>\n\
<p>This What&#39;s New covers changes made in 2019, 2019.1, and 2019.2.</p>\n\
<div class=\'section\'><a id=\"new-in-2019.2\"></a><h2 id=\"new-in-2019.2\">New in 2019.2</h2></div>\n\
<p>The <span class=\'code\'>MPxTransform_BoundingBox</span> class added as a temporary fix for the issue where <span class=\'code\'>MPxTransform::boundingBox()</span> is not called from a command when <span class=\'code\'>MPxTransform::treatAsTransform()</span> returns false. However, this issue was fixed in Maya 2020, and this temporary class was removed from the API.</p>\n\
<blockquote>\n\
<p><strong>Important:</strong> If you are using <span class=\'code\'>MPxTransform_BoundingBox</span>-derived classes, you will need to change back to <span class=\'code\'>MPxTransform</span>-derived classes in Maya 2020.</p>\n\
</blockquote>\n\
<p>A change was made so that <span class=\'code\'>MPxImagePlane</span> no longer needed to be associated with <span class=\'code\'>MPxImagePlaneOverride</span> when drawing a custom image plane in VP2.0. Consequently, the customImagePlane example was updated to use <span class=\'code\'>MPxImagePlane</span> instead of <span class=\'code\'>MPxImagePlaneOverride</span>.</p>\n\
<blockquote>\n\
<p><strong>Important:</strong> If you have any code that uses <span class=\'code\'>MPxImagePlaneOverride</span>, you should update it to use only <span class=\'code\'>MPxImagePlane</span>.</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"new-in-2019.1\"></a><h2 id=\"new-in-2019.1\">New in 2019.1</h2></div>\n\
<p>Only the example plug-ins were modified between 2019 and 2019.1</p>\n\
<p>The following example plug-ins were removed from the devkit:</p>\n\
<ul>\n\
<li>geometryOverrideHighPerformance</li>\n\
<li>AnimEngine A similar example is available from <a href=\'https://github.com/Autodesk/animx\' title=\'\' target=\'_blank\'>https://github.com/Autodesk/animx</a></li>\n\
</ul>\n\
<p>The following example plug-ins were updated:</p>\n\
<ul>\n\
<li>geometryOverrideExample1</li>\n\
<li>geometryOverrideExample2</li>\n\
<li>footPrintNode_GeometryOverride_AnimatedMaterial</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"new-in-2019\"></a><h2 id=\"new-in-2019\">New in 2019</h2></div>\n\
<p>Building with CMake was introduced in 2019.</p>\n\
<p>The embedded version of Python on MacOSX was updated to Python 2.7.15.</p>\n\
<p>As of 2019, Maya sets the <span class=\'code\'>SSL_CERT_FILE</span> environment variable to point to the <span class=\'code\'>cert.pem</span> file within its embedded Python Framework if <span class=\'code\'>SSL_CERT_FILE</span> is unset. To keep <span class=\'code\'>SSL_CERT_FILE</span> unset, the <span class=\'code\'>MAYA_DO_NOT_SET_SSL_CERT_FILE</span> environment variable must be set to 1 before launching Maya.</p>\n\
<p>The following new classes were added to Maya 2019:</p>\n\
<ul>\n\
<li>MColorManagementNodes</li>\n\
<li>MCameraMessage</li>\n\
<li>MPxCacheConfigRuleFilter</li>\n\
<li>MColorPickerUtilities</li>\n\
</ul>\n\
<p>The following new types were added to Maya 2019:</p>\n\
<ul>\n\
<li><span class=\'code\'>MFn::kPinToGeometryUV</span></li>\n\
<li><span class=\'code\'>MFn::kPinToGeometryProx</span></li>\n\
<li><span class=\'code\'>MPolyMessage::kColorSetAdded</span></li>\n\
<li><span class=\'code\'>MPolyMessage::kColorSetDeleted</span></li>\n\
<li><span class=\'code\'>MPolyMessage::kCurrentColorSetChanged</span></li>\n\
<li><span class=\'code\'>MPyMSceneMessage::kAfterCreateReference</span></li>\n\
</ul>\n\
<p>The following new methods were added to Maya 2019:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxGeometryOverride::requiresGeometryUpdate()</span></li>\n\
<li><span class=\'code\'>MPxGeometryOverride::requiresUpdateRenderItems()</span><br></li>\n\
<li><span class=\'code\'>MPxGeometryOverride::supportsEvaluationManagerParallelUpdate()</span></li>\n\
<li><span class=\'code\'>MPxGeometryOverride::supportsVP2CustomCaching()</span></li>\n\
<li><span class=\'code\'>MRenderItem::shadingComponent()</span></li>\n\
<li><span class=\'code\'>MRenderItem::setAllowIsolateSelectCopy()</span></li>\n\
<li><span class=\'code\'>MRenderItem::allowIsolateSelectCopy()</span></li>\n\
<li><span class=\'code\'>MRenderItem::isIsolateSelectCopy()</span></li>\n\
<li><span class=\'code\'>MFnDependencyNode::setAllowedToAnimate()</span></li>\n\
<li><span class=\'code\'>MFnDependencyNode::allowedToAnimate()</span></li>\n\
<li><span class=\'code\'>MGraphEditorInfo::isStackedViewportMode()</span></li>\n\
<li><span class=\'code\'>MGraphEditorInfo::isNormalizedViewportMode()</span></li>\n\
<li><span class=\'code\'>MProfiler::getCategoryInfo()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::cylinder()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::capsule()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::sphere()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::circle()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::circle2d()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::arc()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::arc2d()</span></li>\n\
<li><span class=\'code\'>MUIDrawManager::cone()</span></li>\n\
<li><span class=\'code\'>MPolyMessage::addColorSetChangedCallback()</span></li>\n\
<li><span class=\'code\'>MGlobal::executeTaskOnIdle()</span> (C++ only)</li>\n\
<li><span class=\'code\'>MMessage::stopRegisteringCallableScript()</span></li>\n\
</ul>\n\
<p>The following methods were modified in Maya 2019:</p>\n\
<ul>\n\
<li><span class=\'code\'>MProfiler::addCategory()</span></li>\n\
<li><span class=\'code\'>MProfiler::getAllCategories()</span></li>\n\
<li><span class=\'code\'>MFnMesh::create()</span></li>\n\
<li><span class=\'code\'>MnCloth::setAddCrossLinks()</span></li>\n\
</ul>\n\
<p>The following methods were deprecated in Maya 2019:</p>\n\
<ul>\n\
<li><span class=\'code\'>MHardwareRenderer::theRenderer()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::backEndString()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::makeResourceContextCurrent()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::addDrawProcedure()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::removeDrawProcedure()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::insertDrawProcedure()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::getDrawProcedureCount()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::getDrawProcedureListNames()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::findDrawProcedure()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::restoreCurrent()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::getBufferSize()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::getColorBufferPixelFormat()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::getDepthBufferPixelFormat()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::dereferenceGeometry()</span></li>\n\
<li><span class=\'code\'>MHardwareRenderer::glFunctionTable()</span></li>\n\
<li><span class=\'code\'>M3dView::beginGL()</span></li>\n\
<li><span class=\'code\'>M3dView::endGL()</span></li>\n\
<li><span class=\'code\'>M3dView::setDrawColor(unsigned int, ColorTable)</span></li>\n\
<li><span class=\'code\'>M3dView::setDrawColor(const MColor&amp; )</span></li>\n\
<li><span class=\'code\'>M3dView::setDrawColorAndAlpha()</span></li>\n\
<li><span class=\'code\'>M3dView::colorMask()</span></li>\n\
<li><span class=\'code\'>M3dView::setColorMask()</span></li>\n\
<li><span class=\'code\'>M3dView::drawText()</span></li>\n\
<li><span class=\'code\'>M3dView::readColorBuffer()</span></li>\n\
<li><span class=\'code\'>M3dView::writeColorBuffer()</span></li>\n\
<li><span class=\'code\'>M3dView::readDepthMap()</span></li>\n\
<li><span class=\'code\'>M3dView::readBufferTo2dTexture()</span></li>\n\
<li><span class=\'code\'>M3dView::setMultipleDrawEnable()</span></li>\n\
<li><span class=\'code\'>M3dView::multipleDrawPassCount()</span></li>\n\
<li><span class=\'code\'>M3dView::setMultipleDrawPassCount()</span></li>\n\
<li><span class=\'code\'>M3dView::beginProjMatrixOverride()</span></li>\n\
<li><span class=\'code\'>M3dView::endProjMatrixOverride()</span></li>\n\
</ul>\n\
<p>The following examples were updated in Maya 2019:</p>\n\
<ul>\n\
<li>apiMeshShape</li>\n\
<li>captureViewRenderCmd</li>\n\
<li>footPrintNode_GeometryOverride</li>\n\
<li>uiDrawManager</li>\n\
</ul>\n\
<p>The following examples were added to Maya 2019:</p>\n\
<ul>\n\
<li>geometryOverrideExample1</li>\n\
<li>geometryOverrideExample2</li>\n\
<li>tessellatedQuad</li>\n\
<li>NameFilter</li>\n\
<li>cameraMessageCmd</li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";