var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>What&#39;s new in the Maya 2023 devkit</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>What&#39;s new in the Maya 2023 devkit</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"whats-new-in-the-maya-2023-devkit\"></a></div>\n\
<blockquote>\n\
<p><strong>Update:</strong></p>\n\
<ul>\n\
<li>Maya now uses Python 3.9.7. Python 2 is no longer supported. <a href=$12023-Whats-New-in-API.html#python-changes\' title=\'\'>See the section on Python changes for details.</a></li>\n\
<li>Devkit examples now require CMake version 3.13 or later to compile.</li>\n\
<li>The new minimum version of macOS is now 10.14.</li>\n\
</ul>\n\
</blockquote>\n\
<p>{{toc}}</p>\n\
<div class=\'section\'><a id=\"changes-to-operating-system-requirements-cmake-version-and-third-party-library-locations\"></a><h2 id=\"changes-to-operating-system-requirements-cmake-version-and-third-party-library-locations\">Changes to operating system requirements, CMake version, and third party library locations</h2></div>\n\
<div class=\'section\'><a id=\"new-minimum-macos-version\"></a><h3 id=\"new-minimum-macos-version\">New minimum macOS version</h3></div>\n\
<p>The new minimum version of macOS is 10.14.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"updated-cmake-version\"></a><h3 id=\"updated-cmake-version\">Updated CMake version</h3></div>\n\
<p>Devkit examples now require CMake version 3.13 or later to compile.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"alembic-libraries-have-moved\"></a><h3 id=\"alembic-libraries-have-moved\">Alembic libraries have moved</h3></div>\n\
<p>The Alembic libraries have moved. This change should be transparent as long as you are using the <a href=\'#!/url=./dev_help/SettingUpCMake/LibraryMacros.html\' title=\'\'><span class=\'code\'>find_alembic</span> macro</a> in your <span class=\'code\'>CMakeLists.txt</span> files.</p>\n\
<p>If you are not currently using library macros, you are strongly encouraged to do so.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"python-changes\"></a><h2 id=\"python-changes\">Python changes</h2></div>\n\
<div class=\'section\'><a id=\"python-version-updated-to-3.9\"></a><h3 id=\"python-version-updated-to-3.9\">Python version updated to 3.9</h3></div>\n\
<p>Maya now only supports Python 3. Support for Python 2 has been removed on all platforms. You will need to update your plug-ins and scripts to Python 3.9.</p>\n\
<p>If you have plug-ins or scripts written in Python 3.7, you may encounter issues when porting them to Python 3.9 as code compatibility is not guaranteed between these two versions.</p>\n\
<p>PySide now also builds with Python 3.9.</p>\n\
<p>Consult <a href=\'https://docs.python.org/3/whatsnew/3.8.html\' title=\'\' target=\'_blank\'>What&#39;s New in Python 3.8</a> and <a href=\'https://docs.python.org/3/whatsnew/3.9.html\' title=\'\' target=\'_blank\'>What&#39;s New in Python 3.9</a> for details.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-python-site-packages-directories\"></a><h3 id=\"new-python-site-packages-directories\">New Python site-packages directories</h3></div>\n\
<p>New site-package directories specific to Maya&#39;s release version have been introduced.</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"header\">\n\
<th align=\"left\">Operating system</th>\n\
<th align=\"left\">Path to new site-packages location</th>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">macOS</td>\n\
<td align=\"left\"><span class=\'code\'>$HOME/Library/Preferences/Autodesk/maya/2023/scripts/site-packages</span></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">linux</td>\n\
<td align=\"left\"><span class=\'code\'>$HOME/maya/2023/scripts/site-packages</span></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Windows</td>\n\
<td align=\"left\"><span class=\'code\'>C:/Users/&lt;username&gt;/Documents/maya/2023/scripts/site-packages</span></td>\n\
</tr>\n\
</table>\n\
<p>This is an added directory. Packages will not be moved to this directory, and this directory will not replace any existing directories. However, packages in this directory will be prioritized over Maya&#39;s own site-packages directory.</p>\n\
<p>Use the <span class=\'code\'>pip</span> <span class=\'code\'>--target</span> option to install packages to this location:</p>\n\
<p><span class=\'code\'>mayapy -m pip install &lt;package_name&gt; --target &lt;full_path_to_maya_2023_site-packages&gt;</span></p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"generating-python-code-from-ui-files-using-pyside2-uic\"></a><h3 id=\"generating-python-code-from-ui-files-using-pyside2-uic\">Generating Python code from ui files using pyside2-uic</h3></div>\n\
<p><span class=\'code\'>pyside2-uic</span> and <span class=\'code\'>pyside2-rcc</span> are now included with Maya.</p>\n\
<p>Users can now use <span class=\'code\'>pyside2-uic</span> to generate Python code from <span class=\'code\'>.ui</span> files.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"improvement-to-the-preference-system\"></a><h2 id=\"improvement-to-the-preference-system\">Improvement to the preference system</h2></div>\n\
<p>In order to improve how Maya handles preferences, changes have been made to the <span class=\'code\'>MGlobal</span> class and the <span class=\'code\'>optionVar</span> command.</p>\n\
<p>Three new methods have been added to MGlobal:</p>\n\
<ul>\n\
<li><span class=\'code\'>static bool initOptionVar(const MString&amp; name, int value, const MString&amp; category)</span></li>\n\
<li><span class=\'code\'>static bool initOptionVar(const MString&amp; name, double value, const MString&amp; category)</span></li>\n\
<li><span class=\'code\'>static bool initOptionVar(const MString&amp; name, MString value, const MString&amp; category)</span></li>\n\
</ul>\n\
<p>And several new options and flags have been added to the optionVar command:</p>\n\
<ul>\n\
<li><span class=\'code\'>-intValue2</span> (<span class=\'code\'>-iv2</span>), <span class=\'code\'>-intValue3</span>, (<span class=\'code\'>-iv3</span>), <span class=\'code\'>-intValue4</span> (<span class=\'code\'>-iv4</span>), <span class=\'code\'>-floatValue2</span> (<span class=\'code\'>-fv2</span>), <span class=\'code\'>-floatValue3</span> (<span class=\'code\'>-fv3</span>), <span class=\'code\'>-floatValue4</span> (<span class=\'code\'>-fv4</span>): create 2, 3, or 4 element int or float array variables</li>\n\
<li><span class=\'code\'>-floatArray</span> (<span class=\'code\'>-fa</span>), <span class=\'code\'>-intArray</span> (<span class=\'code\'>-ia</span>), <span class=\'code\'>-stringArray</span> (<span class=\'code\'>-sa</span>): create empty int, float, or string array variables</li>\n\
<li><span class=\'code\'>-transient</span> (<span class=\'code\'>-t</span>): flags that the variable is not to be saved between sessions</li>\n\
<li><span class=\'code\'>-category</span> (<span class=\'code\'>-cat</span>): sets the variable&#39;s category</li>\n\
<li><span class=\'code\'>-default</span> (<span class=\'code\'>-d</span>): sets the variable&#39;s current and default value to the specified value</li>\n\
<li><span class=\'code\'>-init</span> (<span class=\'code\'>-ini</span>): initializes or resets the variable</li>\n\
<li><span class=\'code\'>-listCategories</span> (<span class=\'code\'>-lc</span>): returns a list of all defined variable categories</li>\n\
<li><span class=\'code\'>-listModified</span> (<span class=\'code\'>-lm</span>): returns a list of all variables that have been changed from their default values</li>\n\
</ul>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"api-changes\"></a><h2 id=\"api-changes\">API changes</h2></div>\n\
<div class=\'section\'><a id=\"changes-to-mfnmesh\"></a><h3 id=\"changes-to-mfnmesh\">Changes to MFnMesh</h3></div>\n\
<div class=\'section\'><a id=\"change-to-the-default-tolerance-of-getpointsatuv\"></a><h4 id=\"change-to-the-default-tolerance-of-getpointsatuv\">Change to the default tolerance of getPointsAtUV()</h4></div>\n\
<p>The default tolerance of <span class=\'code\'>MFnMesh::getPointsAtUV()</span> has changed from 0 to 0.001. If no points are found, the method will no longer fail. Instead its arrays of points polygon IDs will be empty.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-and-new-enums\"></a><h4 id=\"new-methods-and-new-enums\">New methods and new enums</h4></div>\n\
<p>The new <span class=\'code\'>BorderInfo</span> enum holds information about whether an edge lies on geometry/UV borders or shares UVs. This enum is returned by the new <span class=\'code\'>edgeBorderInfo()</span> method:</p>\n\
<p><span class=\'code\'>BorderInfo MFnMesh::edgeBorderInfo(int edgeId, unsigned int setId=-1, MStatus *ReturnStatus=NULL) const</span></p>\n\
<p>The new <span class=\'code\'>getUVBorderEdges()</span> method retrieves the edge indecies of edges lying on a UV border:</p>\n\
<p><span class=\'code\'>MStatus MFnMesh::getUVBorderEdges(unsigned int setId, MIntArray &amp;edgeList) const</span></p>\n\
<p>The new <span class=\'code\'>getMeshShellIds()</span> method is the mesh counterpart to <span class=\'code\'>getUvShellsIds()</span>. It returns an array of integers where each unique integer represents a mesh shell. The array lets users identify connected pieces of mesh.</p>\n\
<p><span class=\'code\'>MStatus MFnMesh::getMeshShellsIds(MFn::Type compType, MIntArray &amp; meshShellIds, unsigned int &amp; nbMeshShells)</span></p>\n\
<p>The new <span class=\'code\'>getRawUVs()</span> method returns a pointer to the internal texture coordinates for this mesh.</p>\n\
<p><span class=\'code\'>const float* MFnMesh::getRawUVs(MStatus*, const MString * uvSet = NULL) const;</span></p>\n\
<p>The new <span class=\'code\'>BoolClassification</span> enum indicates whether to use edge classification or normal classification when computing booleans between meshes using the <span class=\'code\'>booleanOps()</span> method.</p>\n\
<p>The signature of <span class=\'code\'>booleanOps()</span> has changed to accommodate the use of this classification:</p>\n\
<p><span class=\'code\'>MStatus MFnMesh::booleanOps(BoolOperation  op, const MObjectArray &amp;meshes, bool useLegacy = false, BoolClassification classification = kNormalClassification)</span></p>\n\
<p>The classification will be ignored if <span class=\'code\'>useLegacy</span> is set to <span class=\'code\'>true</span>.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-overloaded-create-and-createinplace-methods\"></a><h4 id=\"new-overloaded-create-and-createinplace-methods\">New overloaded create() and createInPlace() methods</h4></div>\n\
<p>The new overloaded methods mirror the mesh creation used by mayaAscii and mayaBinary file readers.</p>\n\
<p><span class=\'code\'>MObject create( const MPointArray &amp;vertexArray, const MIntArray &amp;edgeArray, const MIntArray &amp;polygonCounts, const MIntArray &amp;polygonConnects, MObject parentOrOwner = MObject::kNullObj, MStatus * ReturnStatus = NULL )</span></p>\n\
<p><span class=\'code\'>MObject create( const MFloatPointArray &amp;vertexArray, const MIntArray &amp;edgeArray, const MIntArray &amp;polygonCounts, const MIntArray &amp;polygonConnects, MObject parentOrOwner = MObject::kNullObj, MStatus * ReturnStatus = NULL )</span></p>\n\
<p><span class=\'code\'>MObject create( const MPointArray &amp;vertexArray, const MIntArray &amp;edgeArray, const MIntArray &amp;polygonCounts, const MIntArray &amp;polygonConnects, const MFloatArray &amp; uArray, const MFloatArray &amp; vArray, MObject parentOrOwner = MObject::kNullObj, MStatus * ReturnStatus = NULL )</span></p>\n\
<p><span class=\'code\'>MObject create( const MFloatPointArray &amp;vertexArray, const MIntArray &amp;edgeArray, const MIntArray &amp;polygonCounts, const MIntArray &amp;polygonConnects, const MFloatArray &amp; uArray, const MFloatArray &amp; vArray, MObject parentOrOwner = MObject::kNullObj, MStatus * ReturnStatus = NULL );</span></p>\n\
<p><span class=\'code\'>MStatus createInPlace( const MPointArray &amp;vertexArray, const MIntArray &amp;edgeArray, const MIntArray &amp;polygonCounts, const MIntArray &amp;polygonConnects )</span></p>\n\
<p><span class=\'code\'>MStatus createInPlace( const MFloatPointArray &amp;vertexArray, const MIntArray &amp;edgeArray, const MIntArray &amp;polygonCounts, const MIntArray &amp;polygonConnects )</span></p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"change-to-the-way-maya.api.openmaya.mfnmesh-handles-empty-meshes\"></a><h4 id=\"change-to-the-way-maya.api.openmaya.mfnmesh-handles-empty-meshes\">Change to the way maya.api.OpenMaya.MFnMesh() handles empty meshes</h4></div>\n\
<p><span class=\'code\'>maya.api.OpenMaya.MFnMesh()</span> in the Maya Python API 2.0 now returns an error when it is initialized with an empty mesh. This aligns it with the way <span class=\'code\'>maya.OpenMesh.MFnMesh()</span> Maya Python API 1.0 handles empty meshes.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changes-to-mintersectionselectionlevel-and-mselectioncontextselectionlevel-in-openmayarender\"></a><h3 id=\"changes-to-mintersectionselectionlevel-and-mselectioncontextselectionlevel-in-openmayarender\">Changes to MIntersection::SelectionLevel() and MSelectionContext::SelectionLevel in OpenMayaRender</h3></div>\n\
<p>Three new selection levels have been added to the <span class=\'code\'>MSelectionContext::SelectionLevel</span> enum that specifies the granularity to use for a Viewport 2.0 selection:</p>\n\
<ul>\n\
<li><span class=\'code\'>kFace</span>: Face-level selection; only faces are selectable</li>\n\
<li><span class=\'code\'>kEdge</span>:Edge-level selection; only edges are selectable</li>\n\
<li><span class=\'code\'>kVertex</span>:Vertex-level selection; only vertices are selectable</li>\n\
</ul>\n\
<p><span class=\'code\'>kComponent</span> is still a valid selection level for <span class=\'code\'>MSelectionContext::setSelectionLevel()</span> and <span class=\'code\'>MSelectionContext::selectionLevel()</span>. However, for each individual selection hit, <span class=\'code\'>MIntersection::selectionLevel()</span> will no longer return <span class=\'code\'>kComponent</span>. Instead, <span class=\'code\'>MIntersection::selectionLevel()</span> will return one of the three new levels.</p>\n\
<p>Plug-ins that test the selection level of a selection hit against the <span class=\'code\'>kComponent</span> level should be updated to test against the three new levels instead.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changes-to-the-reset-methods-in-mitmeshpolygon-mitmeshedge-and-mitmeshvertex\"></a><h3 id=\"changes-to-the-reset-methods-in-mitmeshpolygon-mitmeshedge-and-mitmeshvertex\">Changes to the reset() methods in MItMeshPolygon, MItMeshEdge, and MItMeshVertex</h3></div>\n\
<p>The following <span class=\'code\'>reset()</span> methods in <span class=\'code\'>MItMeshPolygon</span>, <span class=\'code\'>MItMeshVertex</span>, and <span class=\'code\'>MItMeshEdge</span> have been modified to remove invalid component IDs automatically:</p>\n\
<p><span class=\'code\'>MStatus MItMeshPolygon::reset( const MDagPath &amp;polyObject, MObject &amp; component )</span></p>\n\
<p><span class=\'code\'>MStatus MItMeshVertex::reset( const MDagPath &amp;polyObject, MObject&amp; component )</span></p>\n\
<p><span class=\'code\'>MStatus MItMeshEdge::reset( MObject &amp; polyObject, MObject &amp; component )</span></p>\n\
<p><span class=\'code\'>MStatus MItMeshEdge::reset( const MDagPath &amp;polyObject, MObject &amp; component )</span></p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"enhanced-gpu-deformer-apis\"></a><h3 id=\"enhanced-gpu-deformer-apis\">Enhanced GPU deformer APIs</h3></div>\n\
<p>Three classes and five methods have been added to simplify using GPU deformers.</p>\n\
<p>The <span class=\'code\'>MOpenCLUtils</span>, <span class=\'code\'>MOpenCLKernelInfo</span>, and <span class=\'code\'>MPxGPUStandardDeformer</span> classes have been added.</p>\n\
<p>One new method has been added to <span class=\'code\'>MGPUDeformerRegistrationInfo</span>:</p>\n\
<p><span class=\'code\'>virtual bool isGeometryFilter() const</span></p>\n\
<p>And four new methods have been added to <span class=\'code\'>MPxGPUDeformer</span>:</p>\n\
<p><span class=\'code\'>static bool isBufferUpdateNeeded(const MOpenCLBuffer&amp; buffer, const MEvaluationNode&amp; evaluationNode, const MObject&amp; attribute)</span></p>\n\
<p><span class=\'code\'>cl_int uploadFixedSetupData(const MString&amp; name, MOpenCLBuffer&amp; buffer, cl_int&amp; errorCode, unsigned int* arrayLength)</span></p>\n\
<p><span class=\'code\'>static MFnGeometryData::SubsetState getSubsetState(MDataBlock&amp; block, unsigned int multiIndex, MStatus* ReturnStatus = NULL)</span></p>\n\
<p><span class=\'code\'>static const char* className()</span></p>\n\
<p>The offsetNode example has been updated to use these new classes and methods.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-class-and-methods-added-for-creating-a-color-managed-color-picker\"></a><h3 id=\"new-class-and-methods-added-for-creating-a-color-managed-color-picker\">New class and methods added for creating a color managed color picker</h3></div>\n\
<p>Two new methods, <span class=\'code\'>MColorPickerUtilities::applyViewTransform()</span> and <span class=\'code\'>MColorPickerUtilities::grabColor()</span>, and one new class, <span class=\'code\'>MColorMixingSpaceHelper</span>, have been added for creating a color managed color picker using the API.</p>\n\
<p><span class=\'code\'>MColor MColorPickerUtilities::applyViewTransform(const MColor &amp;inputColor, Direction direction)</span></p>\n\
<p><span class=\'code\'>MColor MColorPickerUtilities::grabColor(MStatus * returnedStatus = nullptr)</span></p>\n\
<p><span class=\'code\'>grabColor()</span> runs an eye dropper tool that lets users interactively grab a color on screen with their mouse. <span class=\'code\'>applyViewTransform()</span> applies a color transform using Maya&#39;s color management settings.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-mtimeslidercustomdrawmanager-class\"></a><h3 id=\"new-mtimeslidercustomdrawmanager-class\">New MTimeSliderCustomDrawManager class</h3></div>\n\
<p>The <span class=\'code\'>MTimeSliderCustomDrawManager</span> class has been added to the Maya API. This class provides a way to draw custom items on the timeline.</p>\n\
<p>In PR131, three callback methods were added:</p>\n\
<p><span class=\'code\'>void setStopPrimitiveEditFunction(MCustomDrawID id, MSharedPtr&lt; MStopPrimitiveEditingFct &gt; fct)</span></p>\n\
<p><span class=\'code\'>void setStartPrimitiveEditFunction(MCustomDrawID id, MSharedPtr&lt; MStartPrimitiveEditingFct &gt; fct)</span></p>\n\
<p><span class=\'code\'>void setEditPrimitiveFunction(MCustomDrawID id, MSharedPtr&lt; MEditPrimitiveFct &gt; fct)</span></p>\n\
<p>The three abstract classes, <span class=\'code\'>MStopPrimitiveEditingFct</span>, <span class=\'code\'>MStartPrimitiveEditingFct</span>, and <span class=\'code\'>MEditPrimitiveFct</span>, were added to support these callbacks.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changed-return-type-on-mindexmapperaffectmap\"></a><h3 id=\"changed-return-type-on-mindexmapperaffectmap\">Changed return type on MIndexMapper::affectMap()</h3></div>\n\
<p>The return type of <span class=\'code\'>MIndexMapper::affectMap()</span> has changed from <span class=\'code\'>MIntArray</span> to <span class=\'code\'>MUintArray</span>.</p>\n\
<p><span class=\'code\'>MUintArray MIndexMapper::affectMap() const</span></p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changes-to-muidrawmanagersettexture\"></a><h3 id=\"changes-to-muidrawmanagersettexture\">Changes to MUIDrawManager::setTexture()</h3></div>\n\
<p>The <span class=\'code\'>MUIDrawManager::setTexture()</span> method has been modified. Two new parameters, <span class=\'code\'>inputColorSpace</span> and <span class=\'code\'>alphaDiscardThreshold</span>, have been added to its signature:</p>\n\
<p><span class=\'code\'>void MUIDrawManager::setTexture(MHWRender::MTexture* texture, const MString&amp; inputColorSpace, const float alphaDiscardThreshold = 0.05f)</span></p>\n\
<p><span class=\'code\'>inputColorSpace</span> is the color space of the texture that will be used to create a shader override when converting texture color to render space color.</p>\n\
<p><span class=\'code\'>alphaDiscardThreshold</span> controls the shader that draws textured UI objects. Any parts of the texture that have an alpha value lower than the threshold will not be drawn. A threshold of 0.0 means everything will be drawn while 1.0 means nothing will be. This parameter was added in PR131.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-selection-highlighting-added-to-mgeometrydrawmode\"></a><h3 id=\"new-selection-highlighting-added-to-mgeometrydrawmode\">New selection highlighting added to MGeometry::DrawMode</h3></div>\n\
<p><span class=\'code\'>kSelectionHighlighting</span> has been added to <span class=\'code\'>MGeometry::DrawMode</span>.</p>\n\
<p>When <span class=\'code\'>kSelectionHighlighting</span> is passed to <span class=\'code\'>MRenderItem::setDrawMode()</span>, the render item will only be drawn if selection highlighting is enabled.</p>\n\
<p>The <span class=\'code\'>gpuCache</span> example has been updated to use this new enum.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-stock-shader-added-to-mhwrendermshadermanager\"></a><h3 id=\"new-stock-shader-added-to-mhwrendermshadermanager\"><a href=\"#!/url=./dev_help/What-s-New-What-s-Changed-/stock/\">New stock shader added to MHWRender::MShaderManager</a></h3></div>\n\
<p>A new stock shader, <span class=\'code\'>k3dIsotropicStandardSurfaceShader</span> has been added to the <span class=\'code\'>MShaderManager</span> class.</p>\n\
<p>The <span class=\'code\'>apiMeshShape</span> example has been updated to use this shader instead of the Blinn shader.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-enum-and-three-new-methods-added-to-mrenderitem\"></a><h3 id=\"new-enum-and-three-new-methods-added-to-mrenderitem\">New enum and three new methods added to MRenderItem</h3></div>\n\
<p>A new enum and three new methods have been added to <span class=\'code\'>MHWRender::MRenderItem</span>.</p>\n\
<p><span class=\'code\'>DefaultMaterialFiltering</span>, <span class=\'code\'>setDefaultMaterialHandling()</span>, and <span class=\'code\'>getDefaultMaterialHandling()</span> were added so that a <span class=\'code\'>MRenderItem</span> can be filtered based on the default material setting of the viewport.</p>\n\
<p><span class=\'code\'>enum DefaultMaterialFiltering</span> specifies how to handle drawing when the default material mode is active.</p>\n\
<p><span class=\'code\'>void MHWRender::MRenderItem::setDefaultMaterialHandling(MRenderItem::DefaultMaterialFiltering state)</span> determines whether this object should be drawn when default material mode is active.</p>\n\
<p><span class=\'code\'>getDefaultMaterialHandling()</span> returns whether this render item will draw when default material mode is active.</p>\n\
<p>And <span class=\'code\'>InternalObjectId()</span> was added to provide a unique identifier for a render item:</p>\n\
<p><span class=\'code\'>MUint64 MHWRender::MRenderItem::InternalObjectId() const</span></p>\n\
<p>It returns a unique identifier for a render item. If two <span class=\'code\'>MRenderItem</span>s hold the same internal render item, they will have the same InternalObjectIds.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-enum-and-two-new-methods-added-to-muidrawmanager\"></a><h3 id=\"new-enum-and-two-new-methods-added-to-muidrawmanager\">New enum and two new methods added to MUIDrawManager</h3></div>\n\
<p>A new enum and new method have been added to <span class=\'code\'>MHWRender::MUIDrawManager</span>.</p>\n\
<p>The <span class=\'code\'>DrawPass</span> enum indicates whether a HUD pass item is drawn before or after the view cube.</p>\n\
<p><span class=\'code\'>beginDrawPass()</span> specifies which draw pass items within the scope of <span class=\'code\'>beginDrawable()</span> and <span class=\'code\'>endDrawable()</span> will be added to.</p>\n\
<p><span class=\'code\'>MStatus MHWRender::MUIDrawManager::beginDrawPass(DrawPass pass)</span></p>\n\
<p>A call to <span class=\'code\'>endDrawPass()</span> must follow a call to <span class=\'code\'>beginDrawPass()</span>.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"two-new-methods-added-to-mpxtransform-and-mpxtransformationmatrix\"></a><h3 id=\"two-new-methods-added-to-mpxtransform-and-mpxtransformationmatrix\">Two new methods added to MPxTransform and MPxTransformationMatrix</h3></div>\n\
<p>Two new methods have been added to replicate joint-like behavior in custom transforms:</p>\n\
<p><span class=\'code\'>MQuaternion MPxTransformationMatrix::preRotation() const</span></p>\n\
<p><span class=\'code\'>MQuaternion MPxTransform::getPreRotation() const</span></p>\n\
<p><span class=\'code\'>MPxTransformationMatrix::preRotation()</span> is an optional rotation that can be applied after the rotation channel and before the translation channel in the transform matrix. It can be used to replicate joint-like behavior in a custom transform.</p>\n\
<p><span class=\'code\'>MPxTransform::getPreRotation()</span> returns the preRotation.</p>\n\
<p>The <span class=\'code\'>rockingTransform</span> example has been modified to use this new functionality.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"two-new-methods-added-to-mplug\"></a><h3 id=\"two-new-methods-added-to-mplug\">Two new methods added to MPlug</h3></div>\n\
<p>Two new methods, <span class=\'code\'>isProxy()</span> and <span class=\'code\'>proxied()</span>, have been added to <span class=\'code\'>MPlug</span>.</p>\n\
<p><span class=\'code\'>bool MPlug::isProxy(MStatus* ReturnStatus ) const</span> <span class=\'code\'>MPlug MPlug::proxied()</span></p>\n\
<p><span class=\'code\'>isProxy()</span> returns true if the plug is a proxy plug. A proxy plug forwards its connection to another plug, and is not associated with a datablock.</p>\n\
<p><span class=\'code\'>proxied()</span> returns the plug the proxy plug forwards to. If the plug is empty or not a proxy plug, <span class=\'code\'>proxied()</span> will return the plug itself. If the plug iis an unconnected proxy, <span class=\'code\'>proxied()</span> will return a null plug.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"thismobject-added-to-several-classes\"></a><h3 id=\"thismobject-added-to-several-classes\">thisMObject() added to several classes</h3></div>\n\
<p><span class=\'code\'>thisMObject()</span> has been added to the following classes</p>\n\
<p>{{#style &quot;tablenobordernocolor&quot;}}</p>\n\
| | | | | | --- | --- | --- | --- | |\n\
<ul>\n\
<li>\n\
MPxCameraSet\n\
</li>\n\
<li>\n\
MPxObjectSet\n\
</li>\n\
<li>\n\
MPxImagePlane\n\
</li>\n\
<li>\n\
MPxSurfaceShape\n\
</li>\n\
</ul>\n\
|\n\
<ul>\n\
<li>\n\
MPxTransform\n\
</li>\n\
<li>\n\
MPxConstraint\n\
</li>\n\
<li>\n\
MPxGeometryFilter\n\
</li>\n\
<li>\n\
MPxIkSolverNode\n\
</li>\n\
</ul>\n\
|\n\
<ul>\n\
<li>\n\
MPxEmitterNode\n\
</li>\n\
<li>\n\
MPxFieldNode\n\
</li>\n\
<li>\n\
MPxParticleAttributeMapperNode\n\
</li>\n\
<li>\n\
MPxSpringNode\n\
</li>\n\
</ul>\n\
|\n\
<ul>\n\
<li>\n\
MPxLocateNode\n\
</li>\n\
<li>\n\
MPxMotionPathNode\n\
</li>\n\
<li>\n\
MPxManipulatorNode\n\
</li>\n\
<li>\n\
MPxThreadedDeviceNode\n\
</li>\n\
</ul>\n\
<p>|</p>\n\
<p>{{/style}}</p>\n\
<div class=\'section\'><a id=\"snaptoactive-added-to-mselectioninfo\"></a><h3 id=\"snaptoactive-added-to-mselectioninfo\">snapToActive() added to MSelectionInfo</h3></div>\n\
<p>The <span class=\'code\'>snapToActive()</span> method has been added to <span class=\'code\'>MSelectionInfo</span>:</p>\n\
<p><span class=\'code\'>bool MHWRender::MSelectionInfo::snapToActive (MStatus* ReturnStatus = nullptr) const</span></p>\n\
<p><span class=\'code\'>snapToActive()</span> returns true if an active object should be snapped to, and returns false otherwise.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"getmemberpaths-added-to-mfnsets\"></a><h3 id=\"getmemberpaths-added-to-mfnsets\">getMemberPaths() added to MFnSets</h3></div>\n\
<p>A new method, <span class=\'code\'>getMemberPaths()</span>, has been added to <span class=\'code\'>MFnSets</span>:</p>\n\
<p><span class=\'code\'>MStatus MFnSet::getMemberPaths(MDagPathArray &amp;members, bool shading) const</span></p>\n\
<p><span class=\'code\'>getMemberPaths()</span> is used to get an array of dagPaths that are members of the set.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"isincrashhandler-added-to-mglobal\"></a><h3 id=\"isincrashhandler-added-to-mglobal\">isInCrashHandler() added to MGlobal</h3></div>\n\
<p>A new method, <span class=\'code\'>isInCrashHandler()</span>, has been added to <span class=\'code\'>MGlobal</span>:</p>\n\
<p><span class=\'code\'>bool MGlobal::isInCrashHandler()</span></p>\n\
<p><span class=\'code\'>isInCrashHandler()</span> lets a plug-in query whether or not Maya has crashed. This is useful in the case where the plug-in is responding to a callback, especially one related to file I/O, as it lets the plug-in know if the callback was triggered by a crash.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"isvalidreference-added-to-mfnreference\"></a><h3 id=\"isvalidreference-added-to-mfnreference\">isValidReference() added to MFnReference</h3></div>\n\
<p>A new method, <span class=\'code\'>isValidReference()</span>, has been added to <span class=\'code\'>MFnReference</span>:</p>\n\
<p><span class=\'code\'>bool MFnReference::isValidReference(MStatus* ReturnStatus = NULL) const</span></p>\n\
<p>The method returns true if the reference is a valid file reference. This method is used to validate a file reference before passing it to other methods, such as <span class=\'code\'>MFnReferemce::isLoaded()</span>, to avoid triggering an exception.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"uniquename-added-to-mfndependencynode\"></a><h3 id=\"uniquename-added-to-mfndependencynode\">uniqueName() added to MFnDependencyNode</h3></div>\n\
<p>A new method, <span class=\'code\'>uniqueName()</span>, has been added to <span class=\'code\'>MFnDependencyNode</span>:</p>\n\
<p><span class=\'code\'>MString MFnDependencyNode::uniqueName(MStatus* ReturnStatus = NULL) const</span></p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"devicepixelratio-added-to-m3dview\"></a><h3 id=\"devicepixelratio-added-to-m3dview\">devicePixelRatio() added to M3dView</h3></div>\n\
<p>A new method, <span class=\'code\'>devicePixelRatio()</span>, has been added to <span class=\'code\'>M3dView</span>:</p>\n\
<p><span class=\'code\'>double M3dView::devicePixelRatio (MStatus* ReturnStatus = NULL) const</span></p>\n\
<p><span class=\'code\'>devicePixelRatio()</span> returns the ratio of Qt logical pixels to viewport rendering pixels for the devide.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"ufeidentifiersinuse-added-to-mpxsubsceneoverride\"></a><h3 id=\"ufeidentifiersinuse-added-to-mpxsubsceneoverride\">ufeIdentifiersInUse() added to MPxSubSceneOverride</h3></div>\n\
<p>A new method, <span class=\'code\'>ufeIdentifiersInUse()</span>, has been added to <span class=\'code\'>MPxSubSceneOverride</span>:</p>\n\
<p><span class=\'code\'>bool MHWRender::MPxSubSceneOverride::ufeIdentifiersInUse() const</span></p>\n\
<p><span class=\'code\'>ufeIdentifiersInUse()</span> returns true when a Maya feature that relies on Ufe Identifiers is enabled.</p>\n\
<div class=\'section\'><a id=\"isempty-added-to-mstring\"></a><h3 id=\"isempty-added-to-mstring\">isEmpty() added to MString</h3></div>\n\
<p>A new method, <span class=\'code\'>isEmpty()</span>, has been added to <span class=\'code\'>MString</span>:</p>\n\
<p><span class=\'code\'>bool MString::isEmpty( ) const</span></p>\n\
<p><span class=\'code\'>isEmpty()</span> will return true if the string is empty. It will return false otherwise.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-overloaded-getreferencenodes-method-added-to-mfileio\"></a><h3 id=\"new-overloaded-getreferencenodes-method-added-to-mfileio\">New overloaded getReferenceNodes() method added to MFileIO</h3></div>\n\
<p>A new overloaded <span class=\'code\'>getReferenceNodes()</span> that has <span class=\'code\'>dagPath</span> as a parameter has been added to <span class=\'code\'>MFileIO</span>.</p>\n\
<p><span class=\'code\'>MStatus MFileIO::getReferenceNodes(const MString &amp; fileName, MStringArray &amp; nodes, bool dagPath)</span></p>\n\
<p>When <span class=\'code\'>dagPath</span> is set to true, the names of any returned dag objects will include enough path to make their names unique. When set to false, the names of the dag objects are returned without a path.</p>\n\
<p><span class=\'code\'>dagPath</span> is false by default, and <span class=\'code\'>getReferenceNodes(const MString&amp; fileName, MStringArray&amp; nodes)</span> will return the names of dag objects without their paths.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"methods-added-to-the-python-api-2.0\"></a><h3 id=\"methods-added-to-the-python-api-2.0\">Methods added to the Python API 2.0</h3></div>\n\
<p>The Python counterparts of the following C++ methods have been added to the Python API 2.0:</p>\n\
<p><span class=\'code\'>virtual void MPxNode::getCacheSetup(const MEvaluationNode&amp;, MNodeCacheDisablingInfo&amp;, MNodeCacheSetupInfo&amp;, MObjectArray&amp;) const</span></p>\n\
<p><span class=\'code\'>virtual void MPxNode::configCache(const MEvaluationNode&amp;, MCacheSchema&amp;) const</span></p>\n\
<p><span class=\'code\'>virtual MTimeRange MPxNode::transformInvalidationRange(const MPlug&amp; source, const MTimeRange&amp; input) const</span></p>\n\
<p><span class=\'code\'>bool MPxNode::hasInvalidationRangeTransformation() const</span></p>\n\
<p><span class=\'code\'>virtual void MPxGeometryOverride::configCache(const MEvaluationNode&amp;, MCacheSchema&amp;) const</span></p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-and-modified-examples\"></a><h2 id=\"new-and-modified-examples\">New and modified examples</h2></div>\n\
<p>A new <span class=\'code\'>py1ArrayAttrBlenderNode.py</span> example demonstrates how to implement array attributes in a straightforward way.</p>\n\
<p>The py1MoveTool.py example has been updated from using VP1 to using VP2, and updated to use Python API 2.0. It has been renamed to py2MoveTool.py.</p>\n\
<p>The <span class=\'code\'>customImagePlane</span> example has been updated to fix an issue where images were not animated when scrubbing.</p>\n\
<p>The <span class=\'code\'>gpuCache</span> example has been updated to use the new <span class=\'code\'>kSelectionHighlighting</span> enum.</p>\n\
<p>The <span class=\'code\'>rockingTransform</span> example has been updated to use the new <span class=\'code\'>preRotation()</span> method in <span class=\'code\'>MPxTransformationMatrix</span>.</p>\n\
<p>The <span class=\'code\'>offsetNode</span> example has been updated to use the new <a href=$12023-Whats-New-in-API.html#enhanced-gpu-deformer-apis\' title=\'\'>GPU deformer API</a>.</p>\n\
<p>The <span class=\'code\'>apiMeshShape</span> example has been updated to remove deprecated code, to fix a bug in the example, and to use the new <a href=$12023-Whats-New-in-API.html#stock\' title=\'\'><span class=\'code\'>k3dIsotropicStandardSurfaceShader</span></a> stock shader.</p>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-blue-pencil-commands\"></a><h2 id=\"new-blue-pencil-commands\">New Blue Pencil commands</h2></div>\n\
<p>The following Blue Pencil commands have been added:</p>\n\
<ul>\n\
<li><span class=\'code\'>bluePencilUtil</span></li>\n\
<li><span class=\'code\'>bluePencilNode</span></li>\n\
<li><span class=\'code\'>bluePencilLayer</span></li>\n\
<li><span class=\'code\'>bluePencilFrame</span></li>\n\
<li><span class=\'code\'>bluePencilStroke</span></li>\n\
<li><span class=\'code\'>bluePencilDrawCtx</span></li>\n\
<li><span class=\'code\'>bluePencilTransformCtx</span></li>\n\
</ul>\n\
<p>These commands were introduced in an earlier PR under similar names prefixed with &quot;cz&quot;, for example <span class=\'code\'>czBluePencilUtil</span>.</p>\n\
<div class=\'section\'><a id=\"other-scripting-and-node-changes\"></a><h2 id=\"other-scripting-and-node-changes\">Other scripting and node changes</h2></div>\n\
<ul>\n\
<li><span class=\'code\'>-fullPath</span> option added to the <span class=\'code\'>duplicate</span> command</li>\n\
<li><span class=\'code\'>-alpha</span> option added to the <span class=\'code\'>displayRGBColor</span> command</li>\n\
<li><span class=\'code\'>-alpha</span> option has been added to the <span class=\'code\'>grabColor</span> command</li>\n\
<li><span class=\'code\'>-connectedGraphingMode</span> option added to the <span class=\'code\'>nodeEditor</span> command</li>\n\
<li><span class=\'code\'>-copyWeights</span> option added to the <span class=\'code\'>blendShape</span> command</li>\n\
<li><span class=\'code\'>-workspaceControls</span> option added to the <span class=\'code\'>lsUI</span> command</li>\n\
<li><span class=\'code\'>-showFullPath</span> option added to the <span class=\'code\'>referenceQuery</span> command</li>\n\
<li><span class=\'code\'>-useVpColorPicker</span> option added to <span class=\'code\'>colorSliderGrp</span>, providing a means to disable the default Viewport color picker.</li>\n\
<li><span class=\'code\'>-tabicon</span> and <span class=\'code\'>-tabIconIndex</span> options added to both the <span class=\'code\'>shelfTabLayout</span> and <span class=\'code\'>tabLayout</span> commands</li>\n\
<li>The <span class=\'code\'>-mayaInstallDir</span> option was added to the <span class=\'code\'>internalVar</span> command. This option returns the directory where Maya is installed. This directory will be identical to the one pointed to by MAYA_LOCATION on Linux and Windows, but will be different than the one pointed to by MAYA_LOCATION on macOS. On macOS, MAYA_LOCATION includes the path to the <span class=\'code\'>Contents</span> folder under <span class=\'code\'>Maya.app</span>. The directory returned by <span class=\'code\'>mayaInstallDir</span> does not include that path.</li>\n\
<li>The <span class=\'code\'>separator</span> <span class=\'code\'>-horizontal</span> option now applies to all styles and not only to <span class=\'code\'>single</span>. It can now be used to specify the orientation of any separator.</li>\n\
<li>The <span class=\'code\'>greasePencilCtx</span>, <span class=\'code\'>greasePencilHelper</span>, and <span class=\'code\'>greaseRenderPlane</span> commands have been removed.</li>\n\
<li>A misleading warning message about OpenMP has been removed from the <span class=\'code\'>threadCount</span> command</li>\n\
<li>The polyBoolean node has been added to Maya.</li>\n\
</ul>\n\
<p><a href=$12023-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";