var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Building Qt examples</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Building Qt examples</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"building-qt-examples\"></a></div>\n\
<p>Maya ships with Qt libraries and header files. These libraries may be different than other Qt libraries installed on your system. This is why it is important that the directory containing the headers packaged with Maya appear in your include path before other Qt header directories, and that the directory containing Maya&#39;s version of the libraries appears in your library path before other Qt library directories.</p>\n\
<p>Use the qmake provided with the Maya devkit to build Qt plug-ins. qmake is located in the devkit&#39;s <span class=\'code\'>bin</span> directory on all platforms.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> Qt plug-ins must be built in the Visual Studio x64 Command Prompt on Windows. Use the Windows search function to find its location on your system.</p>\n\
</blockquote>\n\
<p>Before building Qt examples, set up your environment according to the instructions in <a href=\'#!/url=./dev_help/Setting-up-your-build.html\' title=\'\'>Setting up your build environment</a>.</p>\n\
<p>To build a Qt example:</p>\n\
<ol>\n\
<li>Extract the Qt headers. See <a href=\'#!/url=./dev_help/Working-with-Qt/QtHeadersAndLibraries.html\' title=\'\'>Qt headers and libraries</a> for details.</li>\n\
<li>Locate the plug-in you want to build. Plug-in examples are located in devkit&#39;s <span class=\'code\'>plug-ins</span> directory. Qt example will have <span class=\'code\'>Qt</span> in their names, and the files belonging to a specific example will be named similarly. For example, the <span class=\'code\'>helixQtCmd.cpp</span>, <span class=\'code\'>helixQtCmd.h</span>, and <span class=\'code\'>helixQtCmd.pro</span> files belong to the helixQtCmd.</li>\n\
<li>Run qmake on the <span class=\'code\'>pro</span> file to generate a makefile.</li>\n\
</ol>\n\
<p>For example, on Linux or macOS, you would run:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">```sh\n\
$DEVKIT_LOCATION/devkit/bin/qmake helixQtCmd.pro\n\
```\n\
\n\
On Windows, you would run:\n\
\n\
```sh\n\
%DEVKIT_LOCATION%\\devkit\\qmake.exe helixQtCmd.pro\n\
```\n\
\n\
On macOS, the makefile will have the name of the project with the `.mak` extension added. For example, `helixQtCmd.mak`.\n\
\n\
On Linux and Windows, the makefile will be named `Makefile` regardless of the name of the example.\n\
<ol>\n\
<li></li></ol></pre></div><p>Run <span class=\'code\'>make</span> on the makefile to build the plug-in.</p>\n\
<p>On Linux, run <span class=\'code\'>make –f Makefile</span></p>\n\
<p>On macOS, run <span class=\'code\'>make –f helixQtCmd.mak</span></p>\n\
<p>On Windows, run <span class=\'code\'>nmake /f Makefile</span></p>\n\
\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";